/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_controlplane/controlplane/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKubeadmControlPlanes implements KubeadmControlPlaneInterface
type FakeKubeadmControlPlanes struct {
	Fake *FakeControlplaneV1beta1
	ns   string
}

var kubeadmcontrolplanesResource = schema.GroupVersionResource{Group: "controlplane.cluster.x-k8s.io", Version: "v1beta1", Resource: "kubeadmcontrolplanes"}

var kubeadmcontrolplanesKind = schema.GroupVersionKind{Group: "controlplane.cluster.x-k8s.io", Version: "v1beta1", Kind: "KubeadmControlPlane"}

// Get takes name of the kubeadmControlPlane, and returns the corresponding kubeadmControlPlane object, and an error if there is any.
func (c *FakeKubeadmControlPlanes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.KubeadmControlPlane, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kubeadmcontrolplanesResource, c.ns, name), &v1beta1.KubeadmControlPlane{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlane), err
}

// List takes label and field selectors, and returns the list of KubeadmControlPlanes that match those selectors.
func (c *FakeKubeadmControlPlanes) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.KubeadmControlPlaneList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kubeadmcontrolplanesResource, kubeadmcontrolplanesKind, c.ns, opts), &v1beta1.KubeadmControlPlaneList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.KubeadmControlPlaneList{ListMeta: obj.(*v1beta1.KubeadmControlPlaneList).ListMeta}
	for _, item := range obj.(*v1beta1.KubeadmControlPlaneList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kubeadmControlPlanes.
func (c *FakeKubeadmControlPlanes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kubeadmcontrolplanesResource, c.ns, opts))

}

// Create takes the representation of a kubeadmControlPlane and creates it.  Returns the server's representation of the kubeadmControlPlane, and an error, if there is any.
func (c *FakeKubeadmControlPlanes) Create(ctx context.Context, kubeadmControlPlane *v1beta1.KubeadmControlPlane, opts v1.CreateOptions) (result *v1beta1.KubeadmControlPlane, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kubeadmcontrolplanesResource, c.ns, kubeadmControlPlane), &v1beta1.KubeadmControlPlane{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlane), err
}

// Update takes the representation of a kubeadmControlPlane and updates it. Returns the server's representation of the kubeadmControlPlane, and an error, if there is any.
func (c *FakeKubeadmControlPlanes) Update(ctx context.Context, kubeadmControlPlane *v1beta1.KubeadmControlPlane, opts v1.UpdateOptions) (result *v1beta1.KubeadmControlPlane, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kubeadmcontrolplanesResource, c.ns, kubeadmControlPlane), &v1beta1.KubeadmControlPlane{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlane), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeKubeadmControlPlanes) UpdateStatus(ctx context.Context, kubeadmControlPlane *v1beta1.KubeadmControlPlane, opts v1.UpdateOptions) (*v1beta1.KubeadmControlPlane, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(kubeadmcontrolplanesResource, "status", c.ns, kubeadmControlPlane), &v1beta1.KubeadmControlPlane{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlane), err
}

// Delete takes name of the kubeadmControlPlane and deletes it. Returns an error if one occurs.
func (c *FakeKubeadmControlPlanes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(kubeadmcontrolplanesResource, c.ns, name, opts), &v1beta1.KubeadmControlPlane{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKubeadmControlPlanes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kubeadmcontrolplanesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.KubeadmControlPlaneList{})
	return err
}

// Patch applies the patch and returns the patched kubeadmControlPlane.
func (c *FakeKubeadmControlPlanes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.KubeadmControlPlane, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kubeadmcontrolplanesResource, c.ns, name, pt, data, subresources...), &v1beta1.KubeadmControlPlane{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.KubeadmControlPlane), err
}
